> For the complete documentation index, see [llms.txt](https://docs.umbraco.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.umbraco.com/umbraco-ui-builder/13.latest/filtering/filterable-properties.md).

# Filterable Properties

Umbraco UI Builder can dynamically build a filter dialog choosing appropriate editor views for you based on a basic property configuration. Properties of a number or date types will become range pickers and enums. Properties with options defined will become select/checkbox lists and all other properties will become text input filters.

![Filterable Properties](/files/IerUoMdZspUCjVLPZ6vq)

## Defining filterable properties

Defining filterable properties is controlled via the [collections](/umbraco-ui-builder/13.latest/collections/overview.md) configuration.

### **AddFilterableProperty(Lambda filterablePropertyExpression, Lambda filterConfig = null) : CollectionConfigBuilder\<TEntityType>**

Adds the given property to the filterable properties collection.

```csharp
// Example
collectionConfig.AddFilterableProperty(p => p.FirstName, filterConfig => filterConfig 
    // ...
);
```

## Changing the label of a filterable property

### **SetLabel(string label) : FilterablePropertyConfigBuilder\<TEntityType, TValueType>**

```csharp
// Example
filterConfig.SetLabel("First Name");
```

## Adding a description to a filterable property

### **SetDescription(string description) : FilterablePropertyConfigBuilder\<TEntityType, TValueType>**

```csharp
// Example
filterConfig.SetDescription("The first name of the person");
```

## Defining basic options for a filterable property

### **SetOptions(IDictionary\<TValueType, string> options) : FilterablePropertyConfigBuilder\<TEntityType, TValueType>**

```csharp
// Example
filterConfig.SetOptions(new Dictionary<string, string> {
    { "Option1", "Option One" },
    { "Option2", "Option Two" }
});
```

## Defining options with custom compare clauses for a filterable property

### **AddOption(object key, string label, Lambda compareExpression) : FilterablePropertyConfigBuilder\<TEntityType, TValueType>**

```csharp
// Example
filterConfig.AddOption("Option1", "Option One", (val) => val != "Option Two");
```

## Configuring the mode of a filterable property

For filterable properties with options you can configure whether the options should be multiple or single choice.

### **SetMode(FilterMode mode) : FilterablePropertyConfigBuilder\<TEntityType, TValueType>**

```csharp
// Example
filterConfig.SetMode(FilterMode.MultipleChoice);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.umbraco.com/umbraco-ui-builder/13.latest/filtering/filterable-properties.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
